import { FetchParams, GalleryData, VideoData } from "@/meta/data";

import { Platforms } from "@/meta/settings";

import { fetchXVideosGalleryData } from "./scrape/xvideos/gallery";
import { fetchXvideosVideoData } from "./scrape/xvideos/video";

import { fetchXNXXGalleryData } from "./scrape/xnxx/gallery";
import { XNXX_BASE_URL } from "@/constants/urls";

export class VideoAgent {
  platform: Platforms;
 
  constructor(platform: Platforms) {
    this.platform = platform
  }

  public getGallery = async (params?: FetchParams): Promise<GalleryData[]> => {
    switch (this.platform) {
        case Platforms.xvideos:
            return await fetchXVideosGalleryData(params)
        case Platforms.xnxx:
            return await fetchXNXXGalleryData(params)
        default:
            return []
    }
  }

  public getVideo = async (id: string, params?: FetchParams): Promise<[VideoData, GalleryData[]]> => {
    switch (this.platform) {
        case Platforms.xvideos:
            return await fetchXvideosVideoData(id, params)
            case Platforms.xnxx:
            return await fetchXvideosVideoData(id, { ...params, baseUrl: XNXX_BASE_URL })
        default:
            return [{ lowResUrl: '' }, []]
    }
  }

}